# =====================================================================
# AWK functions for CSA.
# 
# Copyright (c) 2001,2002,2003,2004,2005 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or   
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,  
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: BEGIN.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $

BEGIN {

  # The CMD global variable is used to hold system commands. It is
  # a global name because AWK can have only one system command opened
  # at a time, and the current command needs to be closed before a new
  # one can be opened.

  _NULL = _RESULT = _CMD = ""

  _TRUE = 0; _FALSE = 1

  _RDFPRINT = 1

  # Generic error code.
  _EFAULT	= 255

  # Linux-style symbolic error codes (see errno(3) and <errno.h>).
  _ENOENT	=   2
  _EIO		=   5
  _EACCES	=  13
  _EISDIR	=  21
  _EINVAL	=  22
  _ENOMSG	=  42
  _EMSGSIZE	=  90

  # Various flags and misc. names.
  _O_TRUNC = _O_REQUEST = 0
  _O_APPEND = _O_RESPONSE = _O_MIDDLE = _O_NOENC = 1
  _O_PATHINFO = _O_CURR = _O_MUX = 1
  _O_ATTACH = 2

  _EXIT = "csaExit"
  _EXITOK = "csaExit.ok"
  _EXITFAULT = "csaExit.fault"
  _EXITREDIR = "csaExit.location"

  # Get local settings.
  _CSAINST = ENVIRON["CSA_INSTALL"]
  _STDOUT = ENVIRON["CSA_STDOUT"]
  _STDERR = ENVIRON["CSA_STDERR"]

  # Set default values if necessary.
  if (_CSAINST !~ /^\//) _CSAINST = "/usr/local/csa"
  if (_STDOUT !~ /^\//) _STDOUT = "/dev/stdout"
  if (_STDERR !~ /^\//) _STDERR = "/dev/stderr"
}

