# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2002,2003 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _b64decode.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $
# =====================================================================
# string _b64decode(string value)
#
# Take a base64-encoded string and decode it to its original value. 
# Being mawk(1) not 8-bit clean, the original unencode string should
# not contain values that fall outside the LOCALE charset.
# =====================================================================

function _b64decode(value,		S,n,k,f,i,s,b,z,c) {

  n["/"] = 63
  n["+"] = 62

  for (k=26;k;) {
      n[sprintf(f="%c",--k+65)]=k
      if (k<10) n[sprintf(f,k+48)]=k+52
      n[sprintf(f,97+k)]=26+k
  }

  for (i=1;i<=length(value);) {
      if ((s=substr(value,i++,1)) in n){
         c=n[s]
         if (1==k%=4) {
	    b=z*4+(c-(z=c%16))/16
         }
         else if (!k) z=c
         else if (k==2) {
           b=z*16+(c-(z=c%4))/4
         }
         else if (k==3) b=z*64+c

         if (k++) S = S sprintf(f,b)
      }
  }

  return S
}

