# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2002,2003 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _creat.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $
# =====================================================================
# creat(2): int _creat(string file [, int flag])
#
# 'flag' can be either _O_TRUNC or _O_APPEND. The file will be left
# open in the specified mode on return.
# =====================================================================

function _creat(file,flag,	rc) {

   if (file == "") return _EINVAL
   if (flag != _O_APPEND) flag = _O_TRUNC

   # Check whether we can write to the requested file.
   printf("") >> file
   if ((rc=close(file)) != 0) return _EACCES

   # Yes, we can.
   if (flag == _O_APPEND) { printf("") >> file; return 0 }
   else printf("") > file

   return 0
}

