# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2004 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _wwwexit.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $
# =====================================================================
# int _sys(string statements [, string ofile])
#
# Write the specified shell statements to $CSA_RPC_WWW by default,
# or to whatever file passed in the 2nd argument. The "s" parameter
# must be suitable to be safely eval'ed by the shell, or to whatever
# interpreter 'ofile' is to be executed by. If this function is called
# while processing a response rather than a request, then the default
# output file is $CSA_TPLWB as opposed to $CSA_RPC_WWW.
# =====================================================================

function _sys(s,ofile) {

  if (ofile == _NULL) {

     # request
     if (ENVIRON["CSA_TPLWB"] == _NULL) ofile=ENVIRON["CSA_RPC_WWW"]

     # response
     else {
	ofile=ENVIRON["CSA_TPLWB"]
	_RESULT = _ENOMSG			# tell _envtoxml().
     }
  }
  
  if (ofile !~ /^\//) return 1

  print s > ofile
}

